﻿using System;
using System.Collections.Generic;

public static class Calculation
{
    public static ExitDate OnCalculation(int[] razriads, int winerTime = 0, int youTime = 0)
    {

        ExitDate exitDate = new ExitDate();
        Tabl tableRow = null;
        int razriadId = 5;
        int ratingPoints = Data.GetRatingPoints(razriads);

        for (int i = 0; i < Data.Tablic.Length; i++) //расчет конкретной строки таблицы
        {
            if (Data.Tablic[i].Rating <= ratingPoints)
            {
                tableRow = Data.Tablic[i];
                break;
            }
        }

        if (tableRow == null) return null;

        exitDate.Reyting = tableRow.Rating;

        for (int i = 4; i >= 0; i--) //расчет выполненного разряда
        {
            if (tableRow.RazrKoif[i] == 0) continue;

            float razrKoif = tableRow.RazrKoif[i];
            float timeTo = razrKoif / 100 * winerTime;
            razriadId = i;
            if (timeTo < youTime)
            {
                int notEn = youTime - (int)timeTo;
                exitDate.NotEnoughSeconds = notEn;

                if (i + 1 >= tableRow.RazrKoif.Length || tableRow.RazrKoif[i + 1] == 0)
                {
                    exitDate.IsNullRazriad = true;
                }

                i++;
                razriadId = i;
                break;
            }

        }
        exitDate.NewRazriadId = razriadId + 2; //смещение относительно МС и КМС

        int pointsWinerKoificent = tableRow.RazrKoif[2];

        if (tableRow.RazrKoif[2] == 0)
            pointsWinerKoificent = tableRow.RazrKoif[4] - 30;

        int individualPoints = (int)Math.Round((pointsWinerKoificent / 100d) / (youTime / (double)winerTime) * 1000d);

        exitDate.IndividualPoints = individualPoints;

        return exitDate;
    }

    public static async void RazriadOperations(ClientClass clientInfo, string messageText)
    {
        int razriadCount;

        if (int.TryParse(messageText, out razriadCount) == false || razriadCount < 0)
        {
            clientInfo.ReternCalculation("Ошибка вычисления. Некорректный ввод");
            return;
        }

        int summRazriad = clientInfo.AthletesRazriad.Sum();

        if (10 - summRazriad < razriadCount)
            clientInfo.AthletesRazriad[(int)clientInfo.CalculationStage - 1] = 10 - summRazriad;
        else
            clientInfo.AthletesRazriad[(int)clientInfo.CalculationStage - 1] = razriadCount;

        int summ = clientInfo.AthletesRazriad.Sum();

        if (summ >= 10 || ((int)clientInfo.CalculationStage > 7 && summ >= 1))
        {
            clientInfo.CalculationStage = StageCalculation.GetWinTime;
            await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, $"Время победителя в формате: \nчасы минуты секунды\n Например: \"0 14 53\" - это 14 минут 53 секунды",
                replyMarkup: Data.GetButton());
        }
        else if ((int)clientInfo.CalculationStage > 7 && summ < 1)
        {
            clientInfo.ReternCalculation("Ошибка вычисления. Среди успешно закончивших дистанцию спортсменов, хотя бы один из них должен иметь разряд");
            return;
        }
        else if (summ < 10 && (int)clientInfo.CalculationStage <= 7)
        {
            clientInfo.CalculationStage++;

            string rName = Data.GetRazriad((int)clientInfo.CalculationStage - 1);

            await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, $"Сколько в вашей группе спортсменов с разрядом {rName} успешно закончившие дистанцию? \n(Если таковых больше 10, выберете 10)",
                replyMarkup: Data.GetButton(Data.DEUTIFUL_KEYS));
        }
        else Console.WriteLine("Error date");

    }

    public static async void GetWinTimeOperations(ClientClass clientInfo, string messageText)
    {
        string[] str = messageText.Split();

        if (clientInfo.SetWinnerTime(str) == false)
            return;

        clientInfo.CalculationStage = StageCalculation.GetYouTime;
        await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, $"Ваше время в формате: \nчасы минуты секунды\n Например: \"1 3 53\" - это 1 час 3 минуты 53 секунды");
    }

    public static async void FinalOperations(ClientClass clientInfo, string messageText)
    {
        string[] str = messageText.Split();

        if (clientInfo.SetYouTime(str) == false)
            return;

        if (clientInfo.YouTime < clientInfo.WinnerTime)
        {
            clientInfo.ReternCalculation("Время победителя не может быть меньше вашего. Вычисление прекращено");
            return;
        }

        clientInfo.CalculationStage = StageCalculation.None;
        ExitDate exitCalculation = OnCalculation(clientInfo.AthletesRazriad, clientInfo.WinnerTime, clientInfo.YouTime);

        if (exitCalculation == null)
        {
            clientInfo.ReternCalculation("Ошибка данных");
            return;
        }

        Statistic.CalculationCount++;

        await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, exitCalculation.Reyting + " - рейтинг соревнований", replyMarkup: Data.GetButton("/calculation"));

        if (exitCalculation.IsNullRazriad == false)
            await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, Data.GetRazriad(exitCalculation.NewRazriadId) + " - это ваш новый разряд");
        else
            await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, "Вы не выполнили не один из возможных разрядов \n(для получения 3 юношеского, необходимо в течении года закончить дистанцию в контрольное время 2 раза на официальных спортивных соревнованиях)");

        if (exitCalculation.NewRazriadId > 2 && exitCalculation.NotEnoughSeconds > 0)
            await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, $"До {Data.GetRazriad(exitCalculation.NewRazriadId - 1)} вам нехватило {exitCalculation.NotEnoughSeconds} секунд");

        await Program.Сlient.SendTextMessageAsync(clientInfo.ClientId, $"\n{exitCalculation.IndividualPoints} - ваши личные спортивные очки (эти очки показывают успешность пройденной вами дистанции, их можно сравнивать между различными группами и дистанциями)");
    }
}