﻿using System;
using System.Collections.Generic;

public static class ClientServesis
{
    public static ClientClass GetUserById(long id)
    {
        ClientClass clientInfo;

        foreach (var client in Program.ClientList)
        {
            if (client.ClientId == id)
            {
                clientInfo = client;
                return clientInfo;
            }
        }

        clientInfo = new ClientClass(id);
        Program.ClientList.Add(clientInfo);
        Statistic.UsersCount++;

        return clientInfo;
    }
}

public class ClientClass
{
    public StageCalculation CalculationStage { get; set; }
    public long ClientId { get; private set; }        //     мс кмс 1  2  3 1ю  2ю 3ю
    public int[] AthletesRazriad { get; set; } = new int[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
    public int WinnerTime { get; private set; }
    public int YouTime { get; private set; }

    public bool SetWinnerTime(string[] str)
    {
        int? time = GetTimeFromString(str);
        if (time == null) return false;
        WinnerTime = (int)time;
        return true;
    }

    public bool SetYouTime(string[] str)
    {
        int? time = GetTimeFromString(str);
        if (time == null) return false;
        YouTime = (int)time;
        return true;
    }

    public int? GetTimeFromString(string[] str)
    {
        int timeOut = 0;
        int[] results = new int[str.Length];
        for (int i = 0; i < str.Length; i++)
        {
            if (int.TryParse(str[i], out results[i]) == false || results[i] < 0)
            {
                ReternCalculation("Ошибка вычисления. Вы ввели буквы");
                return null;
            }
        }
        if (results.Length > 3)
        {
            ReternCalculation();
            return null;
        }
        else if (results.Length == 3)
            timeOut = results[0] * 60 * 60 + results[1] * 60 + results[2];
        else if (results.Length > 1)
            timeOut = results[0] * 60 + results[1];
        else if (results.Length == 1)
            timeOut = results[0];
        return timeOut;
    }

    async public void ReternCalculation(string message = "Вы ввели что-то не то. Вычисление прекращено")
    {
        WinnerTime = 0;
        YouTime = 0;
        CalculationStage = StageCalculation.None;
        await Program.Сlient.SendTextMessageAsync(ClientId, message, replyMarkup: Data.GetButton("/calculation"));
    }

    async public void StartComand()
    {
        await Program.Сlient.SendTextMessageAsync(ClientId, "Здравствуй, дорогой ориентировщик! Этот бот поможет тебе рассчитать свой предварительный разряд сразу после получения результатов. Все расчеты проходят по официальным схемам и формулам актуальных на момент 2023 года. Система не вычисляет получение разрядов КМС, МС и тд. Для расчета нажми /calculation",
            replyMarkup: Data.GetButton("/calculation"));
    }

    async public void CalculationComand()
    {
        CalculationStage = StageCalculation.GetMC;
        AthletesRazriad = new int[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
        await Program.Сlient.SendTextMessageAsync(ClientId, "Сначала предупреждаю, чтобы получить разряд, нужно чтобы дистанцию закончили не менее 10 человек. Сколько в вашей группе спортсменов с разрядом МС успешно закончившие дистанцию? \n(Если таковых больше 10, выберете 10)",
            replyMarkup: Data.GetButton(Data.DEUTIFUL_KEYS));
    }

    public ClientClass(long id) { ClientId = id; }
}