﻿using System;
using System.Collections.Generic;
using Telegram.Bot;
using Telegram.Bot.Args;
using Telegram.Bot.Types;

static class Program
{

    public static TelegramBotClient Сlient;
    public static List<ClientClass> ClientList = new List<ClientClass>();
    
    static async Task Main(string[] args)
    {
        const string TOKEN = "TOKEN";

        Statistic.GetDate();
        Statistic.Print();
        Сlient = new TelegramBotClient(TOKEN);
        Сlient.StartReceiving();
        Сlient.OnMessage += OnMessageHandler;
        
        var cancellationTokenSource = new CancellationTokenSource();
        AppDomain.CurrentDomain.ProcessExit += (s, e) => cancellationTokenSource.Cancel();
        Console.CancelKeyPress += (s, e) => cancellationTokenSource.Cancel();
        await Task.Delay(-1, cancellationTokenSource.Token).ContinueWith(t => { });

        Сlient.StopReceiving();
    }

    private static async void OnMessageHandler(object? sender, MessageEventArgs e)
    {
        var message = e.Message;
        ClientClass clientInfo = ClientServesis.GetUserById(message.Chat.Id);

        switch (message.Text)
        {
            case "/start":
                clientInfo.StartComand();
                return;
            case "/calculation":
                clientInfo.CalculationComand();
                return;
        }

        if (clientInfo.CalculationStage == StageCalculation.None) 
            return;

        if ((int)clientInfo.CalculationStage < 9)
        {
            Calculation.RazriadOperations(clientInfo, message.Text);
            return;
        }
        else if (clientInfo.CalculationStage == StageCalculation.GetWinTime)
        {
            Calculation.GetWinTimeOperations(clientInfo, message.Text);
            return;
        }
        else if (clientInfo.CalculationStage == StageCalculation.GetYouTime)
        {
            Calculation.FinalOperations(clientInfo, message.Text);
            return;
        }

        await Сlient.SendTextMessageAsync(clientInfo.ClientId, "Вы ввели что то не то", replyMarkup: Data.GetButton("/calculation"));
    }
}
