﻿using System;
using System.Collections.Generic;
using System.Text.Json;

class SaveDate
{
    public int UsersCount { get; set; }
    public int CalculationsCount { get; set; }
    public List<long> ClientList { get; set; } = new List<long>();

    public SaveDate(int usersCount, int calculationCount)
    {
        UsersCount = usersCount;
        CalculationsCount = calculationCount;

        foreach (var item in Program.ClientList)
            ClientList.Add(item.ClientId);
    }
    public SaveDate() { }
}

static class Statistic
{
    private const string SAVE_PATH = "save.txt";
    private const string LOG_PATH = "output.txt";
    private static int _usersCount;
    private static int _calculationsCount;
    public static int UsersCount
    {
        get => _usersCount;
        set { _usersCount = value; Print(); }
    }
    public static int CalculationCount
    {
        get => _calculationsCount;
        set { _calculationsCount = value; Print(); }
    }

    public static void GetDate()
    {
        if (File.Exists(SAVE_PATH) == false)
        {
            StreamWriter streamWriter = new StreamWriter(SAVE_PATH, false);
            streamWriter.Close();
        }

        StreamReader reader = new StreamReader(SAVE_PATH);
        SaveDate? myDate = null;
        string jsonString = reader.ReadToEnd();

        try { myDate = JsonSerializer.Deserialize<SaveDate>(jsonString); }
        catch (Exception e) { Console.WriteLine(e.Message); }
        reader.Close();

        Program.ClientList = new List<ClientClass>();

        if (myDate == null)
        {
            Console.WriteLine("Data error");
            return;
        }

        _usersCount = myDate.UsersCount;
        _calculationsCount = myDate.CalculationsCount;

        foreach (var item in myDate.ClientList)
            Program.ClientList.Add(new ClientClass(item));
        
    }

    public static void SaveDate()
    {
        SaveDate newDate = new SaveDate(UsersCount, CalculationCount);
        string toSave = JsonSerializer.Serialize<SaveDate>(newDate);
        StreamWriter streamWriter = new StreamWriter(SAVE_PATH, false);
        streamWriter.Write(toSave);
        streamWriter.Close();
    }

    public static void Print()
    {
        StreamWriter streamWriter = new StreamWriter(LOG_PATH, false);
        streamWriter.Write($"Users: {UsersCount}\nCalculations count: {CalculationCount}\n");
        streamWriter.Close();
        SaveDate();
    }

}